/* SPDX-License-Identifier: GPL-2.0 */
//
// ALSA SoC Texas Instruments TAS2118 Audio Smart Amplifier
//
// Copyright (C) 2022 - 2025 Texas Instruments Incorporated
// https://www.ti.com
//
// The TAS2118 driver implements a flexible and configurable
// algo coefficient setting for one, two, or even multiple
// TAS2118 chips.
//
// Author: Shenghao Ding <shenghao-ding@ti.com>
//

#ifndef __TAS2118_TLV_H__
#define __TAS2118_TLV_H__

static const __maybe_unused DECLARE_TLV_DB_SCALE(tas2118_dvc_tlv, -11000, 50, 1);

/*
 * The high 24 bits of the 32-bit vol is pow(10, db/20) * pow(2,22)
 * The low 8 bits is stuffed with 0
 */
static const __maybe_unused unsigned char tas2118_dvc_table[][4] = {
	{ 0x00, 0x00, 0x0D, 0x00 }, /* -110.0db */
	{ 0x00, 0x00, 0x0E, 0x00 }, /* -109.5db */
	{ 0x00, 0x00, 0x0F, 0x00 }, /* -109.0db */
	{ 0x00, 0x00, 0x10, 0x00 }, /* -108.5db */
	{ 0x00, 0x00, 0x11, 0x00 }, /* -108.0db */
	{ 0x00, 0x00, 0x12, 0x00 }, /* -107.5db */
	{ 0x00, 0x00, 0x13, 0x00 }, /* -107.0db */
	{ 0x00, 0x00, 0x14, 0x00 }, /* -106.5db */
	{ 0x00, 0x00, 0x15, 0x00 }, /* -106.0db */
	{ 0x00, 0x00, 0x16, 0x00 }, /* -105.5db */
	{ 0x00, 0x00, 0x18, 0x00 }, /* -105.0db */
	{ 0x00, 0x00, 0x19, 0x00 }, /* -104.5db */
	{ 0x00, 0x00, 0x1A, 0x00 }, /* -104.0db */
	{ 0x00, 0x00, 0x1C, 0x00 }, /* -103.5db */
	{ 0x00, 0x00, 0x1E, 0x00 }, /* -103.0db */
	{ 0x00, 0x00, 0x1F, 0x00 }, /* -102.5db */
	{ 0x00, 0x00, 0x21, 0x00 }, /* -102.0db */
	{ 0x00, 0x00, 0x23, 0x00 }, /* -101.5db */
	{ 0x00, 0x00, 0x25, 0x00 }, /* -101.0db */
	{ 0x00, 0x00, 0x28, 0x00 }, /* -100.5db */
	{ 0x00, 0x00, 0x2A, 0x00 }, /* -100.0db */
	{ 0x00, 0x00, 0x2C, 0x00 }, /* -99.5db */
	{ 0x00, 0x00, 0x2F, 0x00 }, /* -99.0db */
	{ 0x00, 0x00, 0x32, 0x00 }, /* -98.5db */
	{ 0x00, 0x00, 0x35, 0x00 }, /* -98.0db */
	{ 0x00, 0x00, 0x38, 0x00 }, /* -97.5db */
	{ 0x00, 0x00, 0x3B, 0x00 }, /* -97.0db */
	{ 0x00, 0x00, 0x3F, 0x00 }, /* -96.5db */
	{ 0x00, 0x00, 0x42, 0x00 }, /* -96.0db */
	{ 0x00, 0x00, 0x46, 0x00 }, /* -95.5db */
	{ 0x00, 0x00, 0x4B, 0x00 }, /* -95.0db */
	{ 0x00, 0x00, 0x4F, 0x00 }, /* -94.5db */
	{ 0x00, 0x00, 0x54, 0x00 }, /* -94.0db */
	{ 0x00, 0x00, 0x59, 0x00 }, /* -93.5db */
	{ 0x00, 0x00, 0x5E, 0x00 }, /* -93.0db */
	{ 0x00, 0x00, 0x63, 0x00 }, /* -92.5db */
	{ 0x00, 0x00, 0x69, 0x00 }, /* -92.0db */
	{ 0x00, 0x00, 0x70, 0x00 }, /* -91.5db */
	{ 0x00, 0x00, 0x76, 0x00 }, /* -91.0db */
	{ 0x00, 0x00, 0x7D, 0x00 }, /* -90.5db */
	{ 0x00, 0x00, 0x85, 0x00 }, /* -90.0db */
	{ 0x00, 0x00, 0x8C, 0x00 }, /* -89.5db */
	{ 0x00, 0x00, 0x95, 0x00 }, /* -89.0db */
	{ 0x00, 0x00, 0x9E, 0x00 }, /* -88.5db */
	{ 0x00, 0x00, 0xA7, 0x00 }, /* -88.0db */
	{ 0x00, 0x00, 0xB1, 0x00 }, /* -87.5db */
	{ 0x00, 0x00, 0xBB, 0x00 }, /* -87.0db */
	{ 0x00, 0x00, 0xC6, 0x00 }, /* -86.5db */
	{ 0x00, 0x00, 0xD2, 0x00 }, /* -86.0db */
	{ 0x00, 0x00, 0xDF, 0x00 }, /* -85.5db */
	{ 0x00, 0x00, 0xEC, 0x00 }, /* -85.0db */
	{ 0x00, 0x00, 0xFA, 0x00 }, /* -84.5db */
	{ 0x00, 0x01, 0x09, 0x00 }, /* -84.0db */
	{ 0x00, 0x01, 0x18, 0x00 }, /* -83.5db */
	{ 0x00, 0x01, 0x29, 0x00 }, /* -83.0db */
	{ 0x00, 0x01, 0x3B, 0x00 }, /* -82.5db */
	{ 0x00, 0x01, 0x4D, 0x00 }, /* -82.0db */
	{ 0x00, 0x01, 0x61, 0x00 }, /* -81.5db */
	{ 0x00, 0x01, 0x76, 0x00 }, /* -81.0db */
	{ 0x00, 0x01, 0x8C, 0x00 }, /* -80.5db */
	{ 0x00, 0x01, 0xA3, 0x00 }, /* -80.0db */
	{ 0x00, 0x01, 0xBC, 0x00 }, /* -79.5db */
	{ 0x00, 0x01, 0xD7, 0x00 }, /* -79.0db */
	{ 0x00, 0x01, 0xF2, 0x00 }, /* -78.5db */
	{ 0x00, 0x02, 0x10, 0x00 }, /* -78.0db */
	{ 0x00, 0x02, 0x2F, 0x00 }, /* -77.5db */
	{ 0x00, 0x02, 0x50, 0x00 }, /* -77.0db */
	{ 0x00, 0x02, 0x74, 0x00 }, /* -76.5db */
	{ 0x00, 0x02, 0x99, 0x00 }, /* -76.0db */
	{ 0x00, 0x02, 0xC0, 0x00 }, /* -75.5db */
	{ 0x00, 0x02, 0xEA, 0x00 }, /* -75.0db */
	{ 0x00, 0x03, 0x16, 0x00 }, /* -74.5db */
	{ 0x00, 0x03, 0x45, 0x00 }, /* -74.0db */
	{ 0x00, 0x03, 0x76, 0x00 }, /* -73.5db */
	{ 0x00, 0x03, 0xAB, 0x00 }, /* -73.0db */
	{ 0x00, 0x03, 0xE3, 0x00 }, /* -72.5db */
	{ 0x00, 0x04, 0x1E, 0x00 }, /* -72.0db */
	{ 0x00, 0x04, 0x5C, 0x00 }, /* -71.5db */
	{ 0x00, 0x04, 0x9E, 0x00 }, /* -71.0db */
	{ 0x00, 0x04, 0xE4, 0x00 }, /* -70.5db */
	{ 0x00, 0x05, 0x2E, 0x00 }, /* -70.0db */
	{ 0x00, 0x05, 0x7D, 0x00 }, /* -69.5db */
	{ 0x00, 0x05, 0xD0, 0x00 }, /* -69.0db */
	{ 0x00, 0x06, 0x28, 0x00 }, /* -68.5db */
	{ 0x00, 0x06, 0x86, 0x00 }, /* -68.0db */
	{ 0x00, 0x06, 0xE9, 0x00 }, /* -67.5db */
	{ 0x00, 0x07, 0x52, 0x00 }, /* -67.0db */
	{ 0x00, 0x07, 0xC1, 0x00 }, /* -66.5db */
	{ 0x00, 0x08, 0x36, 0x00 }, /* -66.0db */
	{ 0x00, 0x08, 0xB3, 0x00 }, /* -65.5db */
	{ 0x00, 0x09, 0x37, 0x00 }, /* -65.0db */
	{ 0x00, 0x09, 0xC2, 0x00 }, /* -64.5db */
	{ 0x00, 0x0A, 0x56, 0x00 }, /* -64.0db */
	{ 0x00, 0x0A, 0xF3, 0x00 }, /* -63.5db */
	{ 0x00, 0x0B, 0x99, 0x00 }, /* -63.0db */
	{ 0x00, 0x0C, 0x49, 0x00 }, /* -62.5db */
	{ 0x00, 0x0D, 0x04, 0x00 }, /* -62.0db */
	{ 0x00, 0x0D, 0xC9, 0x00 }, /* -61.5db */
	{ 0x00, 0x0E, 0x9A, 0x00 }, /* -61.0db */
	{ 0x00, 0x0F, 0x78, 0x00 }, /* -60.5db */
	{ 0x00, 0x10, 0x62, 0x00 }, /* -60.0db */
	{ 0x00, 0x11, 0x5B, 0x00 }, /* -59.5db */
	{ 0x00, 0x12, 0x62, 0x00 }, /* -59.0db */
	{ 0x00, 0x13, 0x79, 0x00 }, /* -58.5db */
	{ 0x00, 0x14, 0xA0, 0x00 }, /* -58.0db */
	{ 0x00, 0x15, 0xD9, 0x00 }, /* -57.5db */
	{ 0x00, 0x17, 0x25, 0x00 }, /* -57.0db */
	{ 0x00, 0x18, 0x84, 0x00 }, /* -56.5db */
	{ 0x00, 0x19, 0xF8, 0x00 }, /* -56.0db */
	{ 0x00, 0x1B, 0x81, 0x00 }, /* -55.5db */
	{ 0x00, 0x1D, 0x23, 0x00 }, /* -55.0db */
	{ 0x00, 0x1E, 0xDD, 0x00 }, /* -54.5db */
	{ 0x00, 0x20, 0xB1, 0x00 }, /* -54.0db */
	{ 0x00, 0x22, 0xA1, 0x00 }, /* -53.5db */
	{ 0x00, 0x24, 0xAE, 0x00 }, /* -53.0db */
	{ 0x00, 0x26, 0xDA, 0x00 }, /* -52.5db */
	{ 0x00, 0x29, 0x28, 0x00 }, /* -52.0db */
	{ 0x00, 0x2B, 0x98, 0x00 }, /* -51.5db */
	{ 0x00, 0x2E, 0x2D, 0x00 }, /* -51.0db */
	{ 0x00, 0x30, 0xEA, 0x00 }, /* -50.5db */
	{ 0x00, 0x33, 0xD0, 0x00 }, /* -50.0db */
	{ 0x00, 0x36, 0xE1, 0x00 }, /* -49.5db */
	{ 0x00, 0x3A, 0x22, 0x00 }, /* -49.0db */
	{ 0x00, 0x3D, 0x94, 0x00 }, /* -48.5db */
	{ 0x00, 0x41, 0x3A, 0x00 }, /* -48.0db */
	{ 0x00, 0x45, 0x17, 0x00 }, /* -47.5db */
	{ 0x00, 0x49, 0x2F, 0x00 }, /* -47.0db */
	{ 0x00, 0x4D, 0x85, 0x00 }, /* -46.5db */
	{ 0x00, 0x52, 0x1D, 0x00 }, /* -46.0db */
	{ 0x00, 0x56, 0xFB, 0x00 }, /* -45.5db */
	{ 0x00, 0x5C, 0x22, 0x00 }, /* -45.0db */
	{ 0x00, 0x61, 0x98, 0x00 }, /* -44.5db */
	{ 0x00, 0x67, 0x60, 0x00 }, /* -44.0db */
	{ 0x00, 0x6D, 0x80, 0x00 }, /* -43.5db */
	{ 0x00, 0x73, 0xFD, 0x00 }, /* -43.0db */
	{ 0x00, 0x7A, 0xDD, 0x00 }, /* -42.5db */
	{ 0x00, 0x82, 0x25, 0x00 }, /* -42.0db */
	{ 0x00, 0x89, 0xDB, 0x00 }, /* -41.5db */
	{ 0x00, 0x92, 0x06, 0x00 }, /* -41.0db */
	{ 0x00, 0x9A, 0xAD, 0x00 }, /* -40.5db */
	{ 0x00, 0xA3, 0xD7, 0x00 }, /* -40.0db */
	{ 0x00, 0xAD, 0x8C, 0x00 }, /* -39.5db */
	{ 0x00, 0xB7, 0xD5, 0x00 }, /* -39.0db */
	{ 0x00, 0xC2, 0xB9, 0x00 }, /* -38.5db */
	{ 0x00, 0xCE, 0x43, 0x00 }, /* -38.0db */
	{ 0x00, 0xDA, 0x7C, 0x00 }, /* -37.5db */
	{ 0x00, 0xE7, 0x6E, 0x00 }, /* -37.0db */
	{ 0x00, 0xF5, 0x25, 0x00 }, /* -36.5db */
	{ 0x01, 0x03, 0xAB, 0x00 }, /* -36.0db */
	{ 0x01, 0x13, 0x0E, 0x00 }, /* -35.5db */
	{ 0x01, 0x23, 0x5A, 0x00 }, /* -35.0db */
	{ 0x01, 0x34, 0x9E, 0x00 }, /* -34.5db */
	{ 0x01, 0x46, 0xE7, 0x00 }, /* -34.0db */
	{ 0x01, 0x5A, 0x46, 0x00 }, /* -33.5db */
	{ 0x01, 0x6E, 0xCB, 0x00 }, /* -33.0db */
	{ 0x01, 0x84, 0x87, 0x00 }, /* -32.5db */
	{ 0x01, 0x9B, 0x8C, 0x00 }, /* -32.0db */
	{ 0x01, 0xB3, 0xEF, 0x00 }, /* -31.5db */
	{ 0x01, 0xCD, 0xC4, 0x00 }, /* -31.0db */
	{ 0x01, 0xE9, 0x20, 0x00 }, /* -30.5db */
	{ 0x02, 0x06, 0x1C, 0x00 }, /* -30.0db */
	{ 0x02, 0x24, 0xCF, 0x00 }, /* -29.5db */
	{ 0x02, 0x45, 0x54, 0x00 }, /* -29.0db */
	{ 0x02, 0x67, 0xC6, 0x00 }, /* -28.5db */
	{ 0x02, 0x8C, 0x42, 0x00 }, /* -28.0db */
	{ 0x02, 0xB2, 0xE8, 0x00 }, /* -27.5db */
	{ 0x02, 0xDB, 0xD9, 0x00 }, /* -27.0db */
	{ 0x03, 0x07, 0x36, 0x00 }, /* -26.5db */
	{ 0x03, 0x35, 0x25, 0x00 }, /* -26.0db */
	{ 0x03, 0x65, 0xCD, 0x00 }, /* -25.5db */
	{ 0x03, 0x99, 0x57, 0x00 }, /* -25.0db */
	{ 0x03, 0xCF, 0xEF, 0x00 }, /* -24.5db */
	{ 0x04, 0x09, 0xC3, 0x00 }, /* -24.0db */
	{ 0x04, 0x47, 0x04, 0x00 }, /* -23.5db */
	{ 0x04, 0x87, 0xE6, 0x00 }, /* -23.0db */
	{ 0x04, 0xCC, 0xA0, 0x00 }, /* -22.5db */
	{ 0x05, 0x15, 0x6D, 0x00 }, /* -22.0db */
	{ 0x05, 0x62, 0x8B, 0x00 }, /* -21.5db */
	{ 0x05, 0xB4, 0x3A, 0x00 }, /* -21.0db */
	{ 0x06, 0x0A, 0xC0, 0x00 }, /* -20.5db */
	{ 0x06, 0x66, 0x66, 0x00 }, /* -20.0db */
	{ 0x06, 0xC7, 0x7B, 0x00 }, /* -19.5db */
	{ 0x07, 0x2E, 0x51, 0x00 }, /* -19.0db */
	{ 0x07, 0x9B, 0x3E, 0x00 }, /* -18.5db */
	{ 0x08, 0x0E, 0xA0, 0x00 }, /* -18.0db */
	{ 0x08, 0x88, 0xD7, 0x00 }, /* -17.5db */
	{ 0x09, 0x0A, 0x4D, 0x00 }, /* -17.0db */
	{ 0x09, 0x93, 0x6F, 0x00 }, /* -16.5db */
	{ 0x0A, 0x24, 0xB0, 0x00 }, /* -16.0db */
	{ 0x0A, 0xBE, 0x8D, 0x00 }, /* -15.5db */
	{ 0x0B, 0x61, 0x88, 0x00 }, /* -15.0db */
	{ 0x0C, 0x0E, 0x2C, 0x00 }, /* -14.5db */
	{ 0x0C, 0xC5, 0x0A, 0x00 }, /* -14.0db */
	{ 0x0D, 0x86, 0xBE, 0x00 }, /* -13.5db */
	{ 0x0E, 0x53, 0xEC, 0x00 }, /* -13.0db */
	{ 0x0F, 0x2D, 0x42, 0x00 }, /* -12.5db */
	{ 0x10, 0x13, 0x7A, 0x00 }, /* -12.0db */
	{ 0x11, 0x07, 0x55, 0x00 }, /* -11.5db */
	{ 0x12, 0x09, 0xA3, 0x00 }, /* -11.0db */
	{ 0x13, 0x1B, 0x40, 0x00 }, /* -10.5db */
	{ 0x14, 0x3D, 0x13, 0x00 }, /* -10.0db */
	{ 0x15, 0x70, 0x13, 0x00 }, /* -9.5db */
	{ 0x16, 0xB5, 0x43, 0x00 }, /* -9.0db */
	{ 0x18, 0x0D, 0xB8, 0x00 }, /* -8.5db */
	{ 0x19, 0x7A, 0x96, 0x00 }, /* -8.0db */
	{ 0x1A, 0xFD, 0x13, 0x00 }, /* -7.5db */
	{ 0x1C, 0x96, 0x77, 0x00 }, /* -7.0db */
	{ 0x1E, 0x48, 0x1C, 0x00 }, /* -6.5db */
	{ 0x20, 0x13, 0x74, 0x00 }, /* -6.0db */
	{ 0x21, 0xFA, 0x03, 0x00 }, /* -5.5db */
	{ 0x23, 0xFD, 0x66, 0x00 }, /* -5.0db */
	{ 0x26, 0x1F, 0x54, 0x00 }, /* -4.5db */
	{ 0x28, 0x61, 0x9B, 0x00 }, /* -4.0db */
	{ 0x2A, 0xC6, 0x26, 0x00 }, /* -3.5db */
	{ 0x2D, 0x4E, 0xFC, 0x00 }, /* -3.0db */
	{ 0x2F, 0xFE, 0x44, 0x00 }, /* -2.5db */
	{ 0x32, 0xD6, 0x46, 0x00 }, /* -2.0db */
	{ 0x35, 0xD9, 0x6B, 0x00 }, /* -1.5db */
	{ 0x39, 0x0A, 0x41, 0x00 }, /* -1.0db */
	{ 0x3C, 0x6B, 0x7E, 0x00 }, /* -0.5db */
	{ 0x40, 0x00, 0x00, 0x00 }, /* 0.0db */
	{ 0x43, 0xCA, 0xD0, 0x00 }, /* 0.5db */
	{ 0x47, 0xCF, 0x26, 0x00 }, /* 1.0db */
	{ 0x4C, 0x10, 0x6C, 0x00 }, /* 1.5db */
	{ 0x50, 0x92, 0x3C, 0x00 }, /* 2.0db */
	{ 0x55, 0x58, 0x6A, 0x00 }, /* 2.5db */
	{ 0x5A, 0x67, 0x04, 0x00 }, /* 3.0db */
	{ 0x5F, 0xC2, 0x53, 0x00 }, /* 3.5db */
	{ 0x65, 0x6E, 0xE4, 0x00 }, /* 4.0db */
	{ 0x6B, 0x71, 0x86, 0x00 }, /* 4.5db */
	{ 0x71, 0xCF, 0x54, 0x00 }, /* 5.0db */
	{ 0x78, 0x8D, 0xB5, 0x00 }, /* 5.5db */
	{ 0x7F, 0xB2, 0x61, 0x00 }, /* 6.0db */
};
#endif